<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Dynamic Scripting</title>
    <link rel="stylesheet" href="style.css" />
    <script type="text/javascript" src="../packages/hotdrink.js"></script>
    <!--    <script type="module" src="../packages/binders.js"></script>-->
    <script type="module" src="viewer.js"></script>
  </head>
  <body>
    <h1>Dynamic Scripting in a Spreadsheet</h1>

    <!--<input id="upload" accept="image/*" type="file" value="Upload" multiple/>-->

    <table>
      <thead id="thead"></thead>
      <tbody id="tbody"></tbody>
    </table>
    <p>
      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("vars.v0_0%20%3D%20%22%22%3B")'
      >
        Reset constraint system
      </button>
      <button id="createRow">Create row</button>
      <button id="createCol">Create column</button>
    </p>

    <h2>Examples</h2>

    <p>
      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23AddComponent%20%7B%22name%22%3A%22v0_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_1%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v0_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D1%2C1%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v1_1%5Cn)%20%7B%5Cnreturn%20v1_1%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3B")'
      >
        Cell 0,0 references cell 1,1
      </button>
      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23AddComponent%20%7B%22name%22%3A%22v0_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_1%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v0_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D1%2C1%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v1_1%5Cn)%20%7B%5Cnreturn%20v1_1%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3Bvars.v1_1%20%3D%20%225%22%3B")'
      >
        with 1,1 = 5
      </button>
    </p>

    <p>
      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23AddComponent%20%7B%22name%22%3A%22v0_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_1%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v0_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D1%2C1%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v1_1%5Cn)%20%7B%5Cnreturn%20v1_1%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3B%23AddComponent%20%7B%22name%22%3A%22v1_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%222%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v1_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D0%2C0%20%2B%202%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v0_0%5Cn)%20%7B%5Cnreturn%20Number.parseFloat(v0_0)%20%2B%20Number.parseFloat(2)%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3B")'
      >
        Cell 0,0 references cell 1,1, cell 1,0 is 0,0 plus 2
      </button>
      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23AddComponent%20%7B%22name%22%3A%22v0_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_1%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v0_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D1%2C1%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v1_1%5Cn)%20%7B%5Cnreturn%20v1_1%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3B%23AddComponent%20%7B%22name%22%3A%22v1_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%222%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v1_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D0%2C0%20%2B%202%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v0_0%5Cn)%20%7B%5Cnreturn%20Number.parseFloat(v0_0)%20%2B%20Number.parseFloat(2)%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3Bvars.v1_1%20%3D%20%2210%22%3B")'
      >
        with 1,1 = 10
      </button>

      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23AddComponent%20%7B%22name%22%3A%22v0_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_1%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v0_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D1%2C1%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v1_1%5Cn)%20%7B%5Cnreturn%20v1_1%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3B%23AddComponent%20%7B%22name%22%3A%22v1_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%222%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v1_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v1_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D0%2C0%20%2B%202%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v0_0%5Cn)%20%7B%5Cnreturn%20Number.parseFloat(v0_0)%20%2B%20Number.parseFloat(2)%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3Bvars.v1_1%20%3D%20%22a%22%3B")'
      >
        with 1,1 = 'a'
      </button>
    </p>

    <h2>Bad Example</h2>
    <p>
      <button
        id="bad_button"
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23AddComponent%20%7B%22name%22%3A%22v0_0%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v3_3%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v0_0%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D3%2C3%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v3_3%5Cn)%20%7B%5Cnreturn%20v3_3%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3B%23AddComponent%20%7B%22name%22%3A%22v3_3%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v3_2%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v3_3%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v3_3%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D3%2C2%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v3_2%5Cn)%20%7B%5Cnreturn%20v3_2%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3Bvars.v3_2%20%3D%20%22123%22%3B")'
      >
        Reference cells outside vars (works if cell 3,3 exists)
      </button>
      <button
        onclick='hd.defaultConstraintSystem.parseRecorderDSL("%23custom%20create_row%3B%23custom%20create_column%3B%23AddComponent%20%7B%22name%22%3A%22v3_3%22%2C%22variables%22%3A%5B%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v0_0%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22vars%22%2C%22name%22%3A%22v3_3%22%2C%22value%22%3A%22%22%7D%2C%7B%22owner%22%3A%22v3_3%22%2C%22name%22%3A%22code%22%2C%22value%22%3A%22%3D0%2C0%22%7D%5D%2C%22constraints%22%3A%5B%7B%22name%22%3A%22c_0%22%2C%22constraintSpec%22%3A%7B%22methods%22%3A%5B%7B%22name%22%3A%22%22%2C%22nvars%22%3A2%2C%22ins%22%3A%5B0%5D%2C%22outs%22%3A%5B1%5D%2C%22code%22%3A%22function%20anonymous(v0_0%5Cn)%20%7B%5Cnreturn%20v0_0%3B%5Cn%7D%22%2C%22promiseMask%22%3A%5B0%5D%7D%5D%7D%2C%22optional%22%3Afalse%7D%5D%7D%3Bvars.v0_0%20%3D%20%221%22%3B")'
      >
        Fully dynamic example!
      </button>
    </p>
  </body>

  <p></p>
</html>
